#!/bin/bash
#
# Shell script to change all the coding style we have
#
# Copyright 2014 by guy maurel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#  7 february 2014
# 27 february 2014
#
# where you have store the script and the awk-program
BIN=./
DIR=./
WHERE_DIFFS="/home/Diffs"
#
numberOfParameter=$#
if [ $numberOfParameter -eq 0 ] ;
then
  # Parameter is missing, use the actual directory
  WHERE="./"
else
  WHERE=${1}
fi
nameOfTheScript=${0}
#
list=`ls ${WHERE}`
for eachFile in ${list}
do
  if [ -d ${eachFile} ] ;
  then
    # Is a directory
    if [ -r ${eachFile} ] ;
    then
      if [ -a ".no_coding_style" ] 
      then
        #echo "Datei .no_coding_file gefunden"
        exit
      fi
      if [ -a ".no_recursion" ] 
      then
        # do not explore the next directory(ies)
        touch .no_recursion 
      else
        cd ${eachFile}
        liste=`ls -1A`
        for file_1 in ${liste}
        do
          ${nameOfTheScript} ${file_1}
        done
        cd ..
      fi
    fi
  else
    # Is a file
    do_it="no"
    base_1=`basename ${eachFile} .h`
    if [ ${base_1} != ${eachFile} ] ;
    then
      do_it="yes"
    fi
    base_1=`basename ${eachFile} .cpp`
    if [ ${base_1} != ${eachFile} ] ;
    then
      do_it="yes"
    fi
    if [ ${do_it} == "yes" ] ;
    then
      pwd > pwd.txt
      # /home/guy-kde/projects/kdepimlibs/akonadi/contact/actions
      # 123456789=123456789=123456789=
      LAST_DIR=`cut --bytes=24- pwd.txt`
      rm pwd.txt
      #echo "LAST_DIR="${LAST_DIR}
      #echo "mkdir -p ${WHERE_DIFFS=}/${LAST_DIR}"
      mkdir -p ${WHERE_DIFFS}/${LAST_DIR}
      #
      # suppress twice-empty lines
      gawk -f ${DIR}/Twice.awk ${eachFile} > ${eachFile}-t
      mv ${eachFile}-t ${eachFile}
      #
#      # corrections for "switch" **before** astyle because of indentation(s)
#      gawk -f ${DIR}/Switch-Brace-check-change.awk -vmode=change ${eachFile} > ${eachFile}-s
#      mv ${eachFile}-s ${eachFile}
      #
      astyle \
          --suffix=none \
          --indent=spaces \
          --max-instatement-indent=80 \
          --indent-cases \
          --pad-header \
          --pad-oper \
          --unpad-paren \
          --align-pointer=name \
          --align-reference=name \
          --max-instatement-indent=80 \
          --min-conditional-indent=1 \
          ${eachFile}
      #
#      # correction for the case/default leftBrace
#      gawk -f ${DIR}/Case-Brace.awk -vmode=change ${eachFile} > ${eachFile}-c
#      mv ${eachFile}-c ${eachFile}
      #
      # correction for the SIGNAL and SLOT macros
      # qt5
      normalize --modify ${eachFile}
      #
      # correction of normalize
      gawk -f ${DIR}/Normalize-change.awk ${eachFile} > ${eachFile}-n
      mv ${eachFile}-n ${eachFile}
      #
      # add <SPACE> vor ": public"
      gawk -f ${DIR}/Public.awk -vmode=change ${eachFile} > ${eachFile}-p
      mv ${eachFile}-p ${eachFile}
      #
      # change " & " to " &"
      gawk -f ${DIR}/SpaceUND.awk -vmode=change ${eachFile} > ${eachFile}-a
      mv ${eachFile}-a ${eachFile}
      #
      # change "[ " to "[" and " ]" to "]"
      gawk -f ${DIR}/SpaceInArray-change.awk ${eachFile} > ${eachFile}-k
      mv ${eachFile}-k ${eachFile}
      #
      # delete one line if two empties lines are present 
      gawk -f ${DIR}/Twice.awk -v mode=change ${eachFile} > ${eachFile}-b
      mv ${eachFile}-b ${eachFile}
      #
      # delete first/last empty line(s)
      gawk -f ${DIR}/First.awk -v mode=change ${eachFile} > ${eachFile}-c
      mv ${eachFile}-c ${eachFile}
      #
      # lines with initialization(s)
      gawk -f ${DIR}/Default-1.awk -vmode=change < ${eachFile} > ${eachFile}-d1
      mv ${eachFile}-d1 ${eachFile}
#### nicht reif: entitytreemodel_p.cpp:581
      ###gawk -f ${DIR}/Default-2-check-change.awk -vmode=change < ${eachFile} > ${eachFile}-d2
      ###mv ${eachFile}-d2 ${eachFile}
      #
      # corrections for "enum"
      gawk -f ${DIR}/Enum-W.awk -vmode=change ${eachFile} > ${eachFile}-e
      mv ${eachFile}-e ${eachFile}
      #
      # change <SPACE> after keyword
      ${BIN}/coding-style-change-SpaceAfter.sh ${eachFile}
      #
      if [ -f "${DIR}/private_job" ] 
      then
        #echo "private job"
        . ${DIR}/private_job
      fi
    fi
  fi
done
