#!/bin/bash
#
# Shell script to DE-INSTALL all the coding style utilities
#
# Copyright 2014 by guy maurel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# 15 march 2014
#
ID=`id -u`
#echo "ID= $ID"
if [ ${ID} -ne 0 ] ;
then
  echo "you must be root to run"
  exit
fi
#
# where is the configuration info.
ETC_DIR="/etc/CodingStyle/"
#
# read the configuration file.
if [ -f ${ETC_DIR}/CodingStyle.conf ] ;
then
  . ${ETC_DIR}/CodingStyle.conf
else
  exit
fi
echo "LIST_OF_COMMANDS=${LIST_OF_COMMANDS}"
echo "LIST_OF_AWK_FILE=${LIST_OF_AWK_FILE}"
echo "CODING_STYLE_BIN=${CODING_STYLE_BIN}"
echo "CODING_STYLE_DIR=${CODING_STYLE_DIR}"
#
# delete the awk-files
THE_AWK_FILES=`cat ${ETC_DIR}/${LIST_OF_AWK_FILE}`
for each_file in ${THE_AWK_FILES}
do
  echo "de-install awk-file ${each_file}"
  rm ${CODING_STYLE_DIR}/${each_file} 
done
#
# delete the commands
THE_COMMANDS=`cat ${ETC_DIR}/${LIST_OF_COMMANDS}`
for each_file in ${THE_COMMANDS}
do
  echo "delete command ${each_file}"
  rm ${CODING_STYLE_BIN}/${each_file}
done
#
# delete some more files
rm ${ETC_DIR}/${LIST_OF_AWK_FILE}
rm ${ETC_DIR}/${LIST_OF_COMMANDS}

# delete the configuration file.
rm ${ETC_DIR}/CodingStyle.conf
#
# remove the directory where to store the configuration info.
rmdir ${ETC_DIR}
